#!/usr/bin/env python3.5
# -*- coding: utf-8 -*-

#	CDBI	Classe générale	 01 Mars 2019

import os
import shlex,subprocess
from subprocess import call
from datetime import datetime
from time import sleep
import RPi.GPIO as GPIO

class CDBI1:
	#def __init__(self):
	#	sleep(0.001)

	def Taillescreen(self):
		sc=os.popen("xrandr -q -d :0").readlines(1)[0]
		w=sc.split()[7]
		h=sc.split()[9][:-1]
		print ("\033c")		#Pour effacer l'erreur sur le Gamma
		return w,h

	def FenetreDIM(self,fen):
		#Retourne W,H,X,Y
		fen.update()
		g=fen.geometry()
		r=[i for i in range(0,len(g)) if not g[i].isdigit()]
		return [int(g[0:r[0]]),int(g[r[0]+1:r[1]]),int(g[r[1]+1:r[2]]),int(g[r[2]+1:])]

	def Existe(self,f):
		#Fonctionne pour Fichier et Dossier
		return os.path.exists(f)

	def run_cmd(self,cmd):
		return subprocess.check_output(cmd, shell=True).decode('utf-8')

	def get_ip(self):
		#cmd="hostname --all-ip-addresses"
		cmd = "hostname -I | cut -d\' \' -f1"
		return str(self.run_cmd(cmd)[:-1])

	def Extract_Chemin(self,rep,mode):
		r=os.path.split(rep)
		if mode == True:
			#retour du chemin
			return r[0]
		else:
			#retour du nom fichier avec Extension
			return r[1]

	def Explo(self,rep):
		#mode Dossier
		if self.Existe(rep):
			os.chdir(rep)
			os.system("pcmanfm")

	def DIT(self,t,flagSON):
		FichierParle="./DIT.wav"
		if flagSON and (t !=""):
			try:
				#Remplacer les Espaces par des # pour la ligne de commande
				td=str.upper(t)
				td=td.replace(" ","###")
				td=td.replace(".","###,")
				cmd="pico2wave -l=fr-FR -w=" + FichierParle + " %s" %td
				call(cmd,shell=True)
				self.Lire_WAV(FichierParle)
				return 1
			except:
				return 0

	def Lire_WAV(self,f):
		pro=None
		cmd="aplay -q -f S16_LE -r 16000 %s" % f
		pro=subprocess.Popen(shlex.split(cmd),stdin=subprocess.PIPE,stdout=None,stderr=None,bufsize=0)
		#on attend la fin
		while pro.poll() is  None:
			sleep(0.001)
		pro.terminate()

	def BEEP(self,Freq):
		Buz=GPIO.PWM(18,Freq)
		Buz.start(10)
		sleep(0.3)
		Buz.stop()
		sleep(0.1)

	def get_CPUtemp(self):
		t=""
		#cmd="/opt/vc/bin/vcgencmd measure_temp"
		cmd="vcgencmd measure_temp"
		r=str(self.run_cmd(cmd))
		return  r[5:len(r)-3]

	def Verif_Alim(self):
		cmd="vcgencmd get_throttled"
		r=str(self.run_cmd(cmd))
		r=r[10:]
		if r != "0x0":
			return True
		else:
			return False

	def get_Memoire(self):
		cmd = "free -m | awk 'NR==2{printf \"Mem: %s/%sMo %.2f%%\", $3,$2,$3*100/$2 }'"
		return str(self.run_cmd(cmd))

	def get_Disk(self):
		cmd = "df -h | awk '$NF==\"/\"{printf \"Disk: %d/%dGo %s\", $3,$2,$5}'"
		return str(self.run_cmd(cmd))

	def get_CPUload(self,affi):
		#NE FONCTIONNE PAS si pas Terminal
		#cmd = "top -bn1 | grep load | awk '{printf \"%.2f\", $(NF-2)}'"
		#cmd = "top -n1 | awk '/Cpu\(s\):/ {printf $2}'"
		#cmd = "top -b -n 1 | awk '/Cpu\(s\):/'"
		cmd="top -bn1 | grep '%Cpu'"
		r=self.run_cmd(cmd)
		if r !="":
			if affi: print (r)
			r1=r.split()[1]
			r2=r.split()[3]
			#r3=r.split()[11]
			#r4=r.split()[13]
			r1=r1.replace(',','.')
			r2=r2.replace(',','.')
			#r3=r3.replace(',','.')
			#r4=r4.replace(',','.')
			r=round(float(r1)+float(r2),1)
			return str(r)+"%"
		else:
			return "--"

	def now_Heure(self):
		hour = datetime.now().strftime('%H')
		minute = datetime.now().strftime('%M')
		second = datetime.now().strftime('%S')
		return hour,minute,second

	def now_Date(self):
		j=datetime.now().strftime('%d')
		m=datetime.now().strftime('%m')
		a=datetime.now().strftime('%Y')
		return j,m,a
		
	def Formater_Nom(self,rep):
		if self.Existe(rep):
			cmd="find " + rep +" -type f -exec rename 's/ /-/g' {} \;"
			os.system(cmd)
